<!DOCTYPE html>
<html>

<head>
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

</head>

<body>
  <div class="container">
    <h2 style="text-align: center;">Personal Data Submit Form</h2>

    <div class="jumbotron container">
      <div class="row form-group">
        <div class="col-sm-3">
          <label for="input-first-name">First Name</label>
        </div>
        <div class="col-sm-9">
          <input type="text" id="inp-first-name" name="firstname" placeholder="Your first name ..."
            class="form-control">
        </div>
      </div>
      <div class="row form-group">
        <div class="col-sm-3">
          <label for="inp-last-name">Last Name</label>
        </div>
        <div class="col-sm-9">
          <input type="text" id="inp-last-name" name="lastname" placeholder="Your last name.." class="form-control">
        </div>
      </div>
      <div class="row form-group">
        <div class="col-sm-3">
          <label for="age">Age</label>
        </div>
        <div class="col-sm-9">
          <input type="number" id="inp-age" name="age" placeholder="Your age ..." class="form-control">
        </div>
      </div>
      <div class="row">
        <div class="col-sm-12" style="text-align: right;">
          <button id="btn-submit-data" class="btn btn-info">Submit Data</button>
        </div>
      </div>
    </div>
    <!-- HTML Log -->
    <hr>
    <div style="text-align: right;">
      <button id="btn-clear-log" class="btn btn-info"> Clear HTML Log </button>
    </div>
    <p id="p-html-log"></p>
  </div>
</body>

<script>
  "use strict"
    $(document).ready(function(){
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    var gREADY_STATE_REQUEST_DONE = 4;
    var gSTATUS_REQUEST_DONE = 200;
   /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
      $("#btn-submit-data").on("click", onBtnSubmitDataClick);
      $("#btn-clear-log").on("click", onBtnClearHtmlLog);
   /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
      //hàm xử lý việc khi nhấn nút submitdata
      function onBtnSubmitDataClick(){
        "use strict"
        //tạo đối tượng 
        var vPersonobj = {
          firstname: "", 
          lastname: "",
          age: 0
        }

        //Bước 1: thu thập dữ liệu 
        thuThapDuLieu(vPersonobj);
        console.log("Firstname: " + vPersonobj.firstname);
        console.log("Lastname: " + vPersonobj.lastname);
        console.log("Age: " + vPersonobj.age);
      
        //bước 2: kiểm tra dữ liệu 
        var vPersonCheck = kiemTraDuLieu(vPersonobj);
        if(vPersonCheck){
          //bước 3: xử lý hiển thị 
          hienThiThongTin(vPersonobj);
          
        }
        else
        {
          alert("Bạn cần nhập các thông tin cần thiết!!!");
        }

        

      }

      //hàm xử lý việc xóa các thông tin
      function onBtnClearHtmlLog(){
        var vDivHtmlLog = $("#p-html-log");
        vDivHtmlLog.html(">");


      }
  });


   
  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/

  //hàm xử lý việc thu thập dữ liệu 
  function thuThapDuLieu(paramPersonObj){
    "use strict"
    var vInpFirstName = $("#inp-first-name");
    var vInpLastName = $("#inp-last-name");
    var vInpAge = $("#inp-age");

    var vInpFirstNameValue = vInpFirstName.val();
    var vInpLastNameValue = vInpLastName.val();
    var vInpAgeValue = vInpAge.val();

    paramPersonObj.firstname = vInpFirstNameValue;
    paramPersonObj.lastname = vInpLastNameValue;
    paramPersonObj.age = vInpAgeValue;
  }

  //hàm kiểm tra dữ liệu 
  function kiemTraDuLieu(paramPersonObj){
    "use strict"
    if(paramPersonObj.firstname == ""){
      alert("Bạn cần nhập Firstname!!!");
      return false;
    }
    if(paramPersonObj.lastname == ""){
      alert("Bạn cần nhập Lastname!!!");
      return false;
    }
    if(paramPersonObj.age < 0 || paramPersonObj.age > 200){
      alert("Tuổi của bạn không hợp lệ!!!");
      return false;
    }
    return true;
  }

  //hàm xử lý việc hiển thị 
  function hienThiThongTin(paramPersonObj){
    var vInpFirstName = $("#inp-first-name");
    var vInpLastName = $("#inp-last-name");
    var vInpAge = $("#inp-age");

    var vInpFirstNameValue = vInpFirstName.val();
    var vInpLastNameValue = vInpLastName.val();
    var vInpAgeValue = vInpAge.val();

    var vDivHtmlLog = $("#p-html-log");
    var logContent = ">Firstname: " + paramPersonObj.firstname + "<br>";
    logContent += ">Lastname: " + paramPersonObj.lastname + "<br>";
    logContent += ">Age: " + paramPersonObj.age + "<br>";

    vDivHtmlLog.html(logContent);

  }
</script>
</html>